package cn.minbb.edu.controller.rest;

import cn.minbb.edu.data.ResponseResult;
import cn.minbb.edu.model.Banner;
import cn.minbb.edu.service.BannerService;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("")
public class MainController {

    private BannerService bannerService;

    public MainController(BannerService bannerService) {
        this.bannerService = bannerService;
    }

    @GetMapping("banners")
    public ResponseResult<Banner> banners() {
        ResponseResult<Banner> result = new ResponseResult<>();
        result.setSuccess(true);
        result.setDataset(bannerService.findAll());
        result.setMessage("获取成功");
        return result;
    }
}
