package cn.minbb.edu.controller.rest;

import cn.minbb.edu.data.ResponseResult;
import cn.minbb.edu.model.Subject;
import cn.minbb.edu.model.User;
import cn.minbb.edu.service.CourseService;
import cn.minbb.edu.service.SubjectService;
import cn.minbb.edu.service.UserService;
import com.alibaba.fastjson.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("app/subject")
public class SubjectController {

    private UserService userService;
    private CourseService courseService;
    private SubjectService subjectService;

    @Autowired
    public SubjectController(UserService userService, CourseService courseService, SubjectService subjectService) {
        this.userService = userService;
        this.courseService = courseService;
        this.subjectService = subjectService;
    }

    @PostMapping("")
    public ResponseResult<Subject> subject(@RequestBody Map<String, Integer> idMap) {
        Integer id = idMap.get("id");
        if (null == id) {
            return ResponseResult.ok(false).code(-1).message("ID不能为空").dataNone();
        } else {
            Subject subject = subjectService.findOneById(id);
            subject.setVoCourseList(courseService.findAllBySubjectId(id));
            return ResponseResult.ok(true).code(1).message("").data(subject);
        }
    }

    @PostMapping("all")
    public ResponseResult<Subject> subjectAll() {
        List<Subject> subjectList = subjectService.findAll();
        return ResponseResult.ok(true).code(1).message("").dataset(subjectList);
    }

    @PostMapping("user")
    public ResponseResult<Subject> subjectForUser(@RequestBody String userData) {
        User userClient = JSONObject.parseObject(userData, User.class);
        User user = userService.findUserById(userClient.getId());
        List<Subject> subjectList = user.getSubjectList();
        if (null == subjectList || subjectList.isEmpty()) subjectList = subjectService.findAll();
        return ResponseResult.ok(true).code(1).message("").dataset(subjectList);
    }
}
