package cn.minbb.edu.model;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.UpdateTimestamp;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Entity
@Table(name = "banner")
@NoArgsConstructor
@AllArgsConstructor
public class Banner implements Serializable {

    @Getter
    @Setter
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false, columnDefinition = "INT COMMENT '轮播实体'")
    private Integer id;

    @Getter
    @Setter
    @Column(name = "title", nullable = false, columnDefinition = "VARCHAR(64) COMMENT '标题'")
    private String title;

    @Getter
    @Setter
    @Column(name = "subtitle", nullable = true, columnDefinition = "VARCHAR(255) COMMENT '子标题'")
    private String subtitle;

    @Getter
    @Setter
    @Column(name = "action", nullable = false, columnDefinition = "VARCHAR(16) COMMENT '动作提示'")
    private String action;

    @Getter
    @Setter
    @Column(name = "cover", columnDefinition = "VARCHAR(255) COMMENT '封面'")
    private String cover;

    @Getter
    @Setter
    @Column(name = "path", columnDefinition = "VARCHAR(255) COMMENT '路径'")
    private String path;

    @Getter
    @Setter
    @Column(name = "remark", columnDefinition = "VARCHAR(255) COMMENT '备注'")
    private String remark;

    @Getter
    @Setter
    @Column(name = "user_id", nullable = false, columnDefinition = "INT COMMENT '关联用户'")
    private Integer userId;

    @Getter
    @Setter
    @Column(name = "is_enabled", nullable = false, columnDefinition = "TINYINT DEFAULT '1' COMMENT '已启用'")
    private Boolean isEnabled;

    @Getter
    @Setter
    @Column(name = "created_at", columnDefinition = "DATETIME COMMENT '创建时间'")
    @CreationTimestamp
    private Date createdAt;

    @Getter
    @Setter
    @Column(name = "updated_at", columnDefinition = "DATETIME COMMENT '更新时间'")
    @UpdateTimestamp
    private Date updatedAt;

    @Version
    @Column(name = "version", columnDefinition = "INTEGER COMMENT '版本号'")
    public Integer version;

    public Banner(Boolean isEnabled) {
        this.isEnabled = isEnabled;
    }
}
