package cn.minbb.edu.model;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.hibernate.annotations.CreationTimestamp;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Entity
@Table(name = "stage")
@NoArgsConstructor
public class Stage implements Serializable {

    @Getter
    @Setter
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false, columnDefinition = "INT COMMENT '学习阶段实体'")
    private Integer id;

    @Getter
    @Setter
    @Column(name = "name", nullable = false, columnDefinition = "VARCHAR(32) COMMENT '阶段名称'")
    private String name;

    @Getter
    @Setter
    @Column(name = "created_at", columnDefinition = "DATETIME COMMENT '创建时间'")
    @CreationTimestamp
    private Date createdAt;

    public Stage(String name) {
        this.name = name;
    }
}
