package cn.minbb.edu.service.impl;

import cn.minbb.edu.model.Banner;
import cn.minbb.edu.model.repository.BannerRepository;
import cn.minbb.edu.service.BannerService;
import cn.minbb.edu.util.SortTools;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class BannerServiceImpl implements BannerService {

    private BannerRepository bannerRepository;

    @Autowired
    public BannerServiceImpl(BannerRepository bannerRepository) {
        this.bannerRepository = bannerRepository;
    }

    @Override
    public Banner save(Banner banner) {
        banner.setIsEnabled(true);
        return bannerRepository.save(banner);
    }

    @Override
    public List<Banner> findAll() {
        return bannerRepository.findAllByIsEnabledTrue(SortTools.createdAtDown());
    }
}
