package cn.minbb.edu.service.impl;

import cn.minbb.edu.model.Stage;
import cn.minbb.edu.model.repository.StageRepository;
import cn.minbb.edu.service.StageService;
import cn.minbb.edu.util.SortTools;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Example;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class StageServiceImpl implements StageService {

    private StageRepository stageRepository;

    @Autowired
    public StageServiceImpl(StageRepository stageRepository) {
        this.stageRepository = stageRepository;
    }

    @Override
    public Stage save(Stage stage) {
        return stageRepository.save(stage);
    }

    @Override
    public Stage findOneById(Integer id) {
        Stage stage = new Stage();
        stage.setId(id);
        return stageRepository.findOne(Example.of(stage)).orElse(null);
    }

    @Override
    public Stage findOneByName(String name) {
        return stageRepository.findOne(Example.of(new Stage(name))).orElse(null);
    }

    @Override
    public List<Stage> findAll() {
        return stageRepository.findAll(SortTools.createdAtDown());
    }
}
