package cn.minbb.edu.service.impl;

import cn.minbb.edu.model.Subject;
import cn.minbb.edu.model.repository.SubjectRepository;
import cn.minbb.edu.service.SubjectService;
import cn.minbb.edu.util.SortTools;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Example;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class SubjectServiceImpl implements SubjectService {

    private SubjectRepository subjectRepository;

    @Autowired
    public SubjectServiceImpl(SubjectRepository subjectRepository) {
        this.subjectRepository = subjectRepository;
    }

    @Override
    public Subject save(Subject subject) {
        return subjectRepository.save(subject);
    }

    @Override
    public Subject findOneById(Integer id) {
        Subject subject = new Subject();
        subject.setId(id);
        return subjectRepository.findOne(Example.of(subject)).orElse(null);
    }

    @Override
    public Subject findOneByName(String name) {
        return subjectRepository.findOne(Example.of(new Subject(name))).orElse(null);
    }

    @Override
    public List<Subject> findAll() {
        return subjectRepository.findAll(SortTools.createdAtDown());
    }

    @Override
    public List<Subject> findAllByIdIn(List<Integer> ids) {
        return subjectRepository.findAllByIdIn(ids);
    }
}
