package cn.minbb.edu.service.impl;

import cn.minbb.edu.model.UserRole;
import cn.minbb.edu.model.repository.UserRoleRepository;
import cn.minbb.edu.service.UserRoleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashSet;
import java.util.Set;

@Service
public class UserRoleServiceImpl implements UserRoleService {

    private UserRoleRepository userRoleRepository;

    @Autowired
    public UserRoleServiceImpl(UserRoleRepository userRoleRepository) {
        this.userRoleRepository = userRoleRepository;
    }

    @Override
    public UserRole saveOne(UserRole userRole) {
        return userRoleRepository.save(userRole);
    }

    @Override
    public UserRole findOneByRole(UserRole.Role role) {
        return null == role ? null : userRoleRepository.findOneByRole(role);
    }

    @Override
    public Set<UserRole> findAll() {
        return new HashSet<>(userRoleRepository.findAll());
    }

    @Override
    public Set<UserRole> findAllByRoleSet(Set<UserRole.Role> roleSet) {
        if (roleSet.isEmpty()) return new HashSet<>();
        return userRoleRepository.findAllByRoleIn(roleSet);
    }
}
