package cn.minbb.edu.util;

import org.springframework.data.domain.Sort;

public class SortTools {

    private SortTools() {
    }

    public static Sort idUp() {
        return new Sort(Sort.Direction.ASC, "id");
    }

    public static Sort idDown() {
        return new Sort(Sort.Direction.DESC, "id");
    }

    public static Sort createdAtUp() {
        return new Sort(Sort.Direction.ASC, "createdAt");
    }

    public static Sort createdAtDown() {
        return new Sort(Sort.Direction.DESC, "createdAt");
    }

    public static Sort basicAscSort(String sort) {
        return new Sort(Sort.Direction.ASC, sort);
    }

    public static Sort basicDescSort(String sort) {
        return new Sort(Sort.Direction.DESC, sort);
    }

    /**
     * 基本排序
     *
     * @param order 默认降序 - desc
     * @param sort  默认ID - id
     * @return 排序规则
     */
    public static Sort basicSort(String order, String sort) {
        if (order == null) {
            order = "desc";
        }
        if (sort == null) {
            sort = "id";
        }
        return new Sort(Sort.Direction.fromString(order), sort);
    }
}
